// 
#include <AnalogKey.h>
#include <GyverButton.h>              //  
#include <Strela.h>                   //  ""
#include <Servo.h>                    //  
#include <Wire.h>                     //  1wire
#define _LCD_TYPE 1
#include <LiquidCrystal_I2C.h>        //  
#include <DS_raw.h>
#include <microDS18B20.h>             //  DS18B20
#include <microOneWire.h>
// 
#define LED P2                        //""
#define servo P3                      //
#define relay P4                      //
#define thermo P5                     //.  
#define light P6                      // 
#define butY P7                       //   
#define butR P8                       //  
#define level P11                     //  
#define light_level 500               //  ""
uint8_t address[8] = {0x28, 0xFF, 0x64, 0x1F, 0x7F, 0xCC, 0x56, 0xAB}; // DS18B20
bool relay_c = 0;                     // 
bool temp = 0;                        // 
LiquidCrystal_I2C lcd(0x27, 16, 2);   // 
MicroDS18B20<thermo, address> sensor; // DS18B20
Servo myservo;                        // 
GButton buttY(butY, LOW_PULL);        // 
GButton buttR(butR, LOW_PULL);        // 
 
byte snowflake[] = {0x00, 0x15, 0x0E, 0x1F, 0x0E, 0x15, 0x00, 0x00};  //
byte gradus[] = {0x1C, 0x14, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00};     //
 
void setup() {
  buttY.tick();                       // 
  uPinMode(LED, OUTPUT);              // 
  uPinMode(relay, OUTPUT);            // 
  uPinMode(level, INPUT_PULLUP);      //  
  Serial.begin(9600);                 //    
  Serial.println("setup");            //  
  myservo.attach(servo);              // 
  myservo.write(165);                 // 
  uDigitalWrite(servo, 0);
  HelloLCD();                         // 
  sensor.requestTemp();                           // 
  delay(1000);                                    //
  lcd.createChar(2, snowflake);                   // ""
  lcd.createChar(3, gradus);                      // ""
  //  
  Serial.println(sensor.getTempInt());
  //  
}
 
void loop() {
  uDigitalWrite(servo, 0);
  buttY.tick();                       // 
  buttR.tick();                       // 
  sensor.requestTemp();               // 
  TempLCD();                          //   
  uDigitalWrite(relay, relay_c);      //  
  if (buttR.isClick()) {              //  
    if (relay_c == 1) relay_c = 0;    // .  - , . 
    else relay_c++;                   // -  
  }
  if (sensor.readTemp()) {            // t 
    if (sensor.getTempInt() <= 18) {  // t < 18
      drive(107, 107);                // 
      lcd.setCursor(7, 1);            // 
      lcd.print("Heating");           // 
    }
    if (sensor.getTempInt() <= 16) {  // t < 16
      tone(BUZZER, 1000, 1000);       // 
      lcd.setCursor(13, 0);           // 
      lcd.write(2);                   // ""
      delay(500);
    }
    // t > 24  
    if (sensor.getTempInt() >= 24) temp = 1;
    else if (temp == 1) temp = 0;     //  
    //  
    if (temp == 1) {
      drive(0, 0);                    // 
      lcd.clear();                    // 
      delay(100);                     //
    }
  }
//  if (buttY.isHold()) EEPROM.update(4, 23);
  if (buttY.isClick()) {               //  
    myservo.write(90);                 // 
    delay(300);                        //  
    myservo.write(165);                // 
    uDigitalWrite(servo, 0);
  }
  //    
  if (uDigitalRead(level) == 0) relay_c = 0;
  //  
  if (uAnalogRead(light) >= light_level) {
    uDigitalWrite(LED, 1);            // 
    lcd.backlight();                  // 
  }
  else  {                             //
    uDigitalWrite(LED, 0);            // 
    lcd.noBacklight();                // 
  }
}
 
void TempLCD() {                      // t  
  lcd.setCursor(1, 0);                // 
  lcd.print("Temperature");           // 
  lcd.setCursor(2, 1);                // 
  if (sensor.readTemp()) {            // t 
    lcd.print(sensor.getTempInt());   // 
    lcd.setCursor(4, 1);              // 
    lcd.write(3);                     // ""
    lcd.setCursor(5, 1);              // 
    lcd.print("C");                   // ""
    //  
    Serial.println("TempLCD");
  }
  else lcd.print("sensor error");     //  "error"
}
void HelloLCD() {          //
  lcd.init();              // 
  lcd.clear();             // 
  lcd.setCursor(1, 0);     // 
  lcd.print("SMART AQUARIUM"); //  ""
  lcd.setCursor(1, 1);     // 
  lcd.print("by Xuxumuku");//  "by "
  delay(2000);             //
  lcd.clear();             // 
  //  
  Serial.println("Hello");
}